#!/usr/bin/perl

#================================ 
#
# http://www.magicdirectory.com
# Copyright 2006 Jonathan Gamble
# Version 1.02
# Freeware... just keep this heading
#

use strict; 
use lib 'admin path';
use Links qw/:objects/;
use Links::SiteHTML;
use IO::Dir;

Links::init('admin path');

local $SIG{__DIE__} = \&Links::fatal; 
main();

use constant SCRIPTNAME => "tables.cgi";

sub main {
#---------------------------------------------------
#

	print $IN->header();

	# if the fields values have been received

	if ($IN->param('create')) {

		# create the table and fields

		&createTable;

		# print success

		print "<font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>The table <b>" . $IN->param('tablename') . "</b> was created successfully!</font><p>";

		&printDefs;

	}

	# if the table name and number of fields have been received

	elsif ($IN->param('submit')) {

		# make sure all the required information is there

		if (!$IN->param('tableName') || !$IN->param('fields')) {

			print "<font face='Tahoma,Arial,Helvetica' size='2' color='red'>Error: You must enter a table name and the number of fields!</font><p>";

			&printDefs;

		}

		else {

			# print the field form(s)

			my $scriptName = SCRIPTNAME;

			print "<form method=POST action=$scriptName name=admin>\n";

			print "<input type=hidden name=tablename value=" . $IN->param('tableName') . ">";
			print "<input type=hidden name=fields value=" . $IN->param('fields') . ">";

			# findout how many new fields we are adding

			for (my $c=1; $c <= $IN->param('fields'); $c++) {

				# print "<input type=hidden name=pos value=1>";
				# only good when creating one column

				printForm($c);
			
			}

			&printCreateButton;


		}

	}

	# if table drop request

	elsif ($IN->param('drop') == 1) {


		if ($IN->param('confirm')) {

			if ($IN->param('confirm') == 1) {
	
				my $c = $DB->creator($IN->param('table'));
	
				$c->drop_table or die "Unable to drop: $GT::SQL::error";
	
				print "<font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>The table <b>".$IN->param('table')."</b> was dropped successfully!<p></font>";
	
				&printDefs;
	
			}

			else {

				&printDefs;
	
			}

		}
	
		else {
	
			drop_confirm();
	
		}

	}

	# if no user input, print the page

	else {

		&printDefs;

	}

}

sub printForm {
#---------------------------------------------------
#
my $n = shift;

print qq~

<p><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>For information on what each column means, <b><a href="admin.cgi?do=editor_column_help&db=Links">click here</a></b>.</p>
    
    <table width=500 border=1 cellpadding=0 cellspacing=0><tr><td>
    <table border=0 width=500>
          <tr><td colspan=2 bgcolor="#DDDDDD"><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'><b>Database Information</b></font></td></tr>
          <tr><td><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>Column Name</td><td><input type=text name=column$n value=""></td></tr>
        
    <tr><td><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>Column Type</td><td><select name="type$n">
        <option selected>
        <option>INT
        <option>CHAR
        <option>TEXT
        <option>DATE
        <option>ENUM
        </select>
    </td></tr>
    <tr><td><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>Column Index</td><td><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'><select name="index$n"><option value="none" SELECTED>None</option><option value="regular">Regular</option><option value="unique">Unique</option><option value="primary">Primary Key</option></select></td></tr>
    <tr><td><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>Column Size<br>(Only for CHAR types)</td><td><input type=text name=size$n value=""></td></tr>
    <tr><td><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>Column Values<br>(Only for ENUM types)</td><td><textarea name=values$n rows=3 cols=20></textarea></td></tr>
    <tr><td><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>Not Null
    </td><td><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>
        Yes<input name="not_null$n" type=radio value=1>
        No<input name="not_null$n" type=radio value=0 checked>
    </td></tr>
    <tr><td height="48"><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>Default</td>
		<td height="48"><input type="text" name=default$n value=""></td></tr>
    <tr><td colspan=2 bgcolor="#DDDDDD"><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'><b>Form Information</b></font></td></tr>
    <tr><td><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>Form Display</td><td><input type="text" name=form_display$n value=""></td></tr>
    <tr><td><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>Form Type</td><td>
    <select name=form_type$n>
        <option value="HIDDEN">HIDDEN</option>
        <option value="SELECT">SELECT</option>
        <option value="MULTIPLE">MULTI-SELECT</option>
        <option value="CHECKBOX">CHECKBOX</option>
        <option value="RADIO">RADIO</option>
        <option selected value="TEXT">TEXT</option>
        <option value="TEXTAREA">TEXTAREA</option>
        <option value="PASSWORD">PASSWORD</option>
        <option value="FILE">FILE</option>
    </select></td></tr>
    <tr><td><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>Form Size</td><td><input type=text name=form_size$n value=""></td></tr>
    <tr><td valign="top"><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>Form Names<br>(Stored in Database)<br>Only for checkbox, multi-select or radio forms.</td><td valign="top"><textarea cols=20 rows=3 name=form_names$n></textarea></td></tr>
    <tr><td valign="top"><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>Form Values<br>(Displayed on Form)<br>Only for checkbox, multi-select or radio forms.</td><td valign="top"><textarea cols=20 rows=3 name=form_values$n></textarea></td></tr>
    <tr><td><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>File Save Location<br>(Only for FILE types. Stored on disk)</td><td><input type=text name=file_save_in$n value=""></td></tr>
    <tr><td><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>File Save URL<br>(Only for FILE types)</td><td><input type=text name=file_save_url$n value=""></td></tr>
    <tr><td><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>File Save Method<br>(Only for FILE types)</td><td><select name=file_save_scheme$n>
        <option>HASHED</option>
        <option>SIMPLE</option>
        </select>
    </td></tr>
    <tr><td><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>File Maximum Size<br>(Only for FILE types.)</td><td><input type=text name=file_max_size$n value=""></td></tr>

    <tr><td><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>Form Regex</td><td><input type=text name=regex$n value=""></td></tr>
    
    </table>
    </tr></td></table>
    <br>

~;


}

sub printCreateForm {
#---------------------------------------------------
#

my $scriptName = SCRIPTNAME;

print qq~

<form method=POST action=$scriptName name=admin>

<table border=1 cellpadding=0 cellspacing=0>
    <tr>
        <td>
            <table border=0 bgcolor="#FFFFFF" cellpadding=3 cellspacing=3 width=500 valign=top>
                <tr>
                    <td align=left bgcolor="navy">
                        <font face='Arial' size='2' color='#FFFFFF'><b>Create a Table</b></font>
                    </td>
                </tr>
                <tr>
                    <td>
                        <p>
						<div align="center">
							<table border="0" id="table1" width="100%">
								<tr>
									<td width="293"><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>
									Table Name:</font></td>
									<td width="190">
									<font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>
						<input type=text name="tableName" value="" size="20"></font></td>
								</tr>
								<tr>
									<td>
									<font face="Tahoma,Arial,Helvetica" size="2">
									Number of Fields:</font></td>
									<td width="190">
									<font face="Tahoma,Arial,Helvetica" size="2">
									<input type="text" name="fields" size="5" value="1"></font></td>
								</tr>
							</table>
							<p>
							<font face="Tahoma,Arial,Helvetica" size="2" color="#000000">
							<input type=submit name=submit value="Create Table"></font></div>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
</table>

</form>

~;

}

sub printCreateButton {
#---------------------------------------------------
#
	print qq~&nbsp;<table border=1 cellpadding=0 cellspacing=0 id="table1"><tr><td align=center>
    <table border=0 width=500 id="table2"><tr><td align=center><center><font face="Tahoma,Arial,Helvetica" size="2"><input type=submit name=create value="Create Table and Add Field"></font></center></td></tr></table>
</td></tr></table>
    <p>~;


}

sub printDefs {
#---------------------------------------------------
#
	my @tables = @_;

	my ($t, $noshow);

	my $defURL = $CFG->{admin_root_url} . "/defs";

	my $defPath = $CFG->{admin_root_path} . "/defs";

	my $d = IO::Dir->new($defPath) || die "Could not open dirhandle! $!\n";

	&printTableHeader;

        my $pre = $DB->prefix();

        print "<b>Table Prefix: " . $pre . "</b>";

	while (defined(my $file = $d->read)) {

		# Hide GT Tables
	
		if ($file ne '.' && $file ne '..' && $file ne 'database.def') {

			$file =~ s/.def//;

                        $file =~ s/$pre//;
                        
			print "<tr>\n";

			print qq|<td width="293"><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>|;

			print $file . "</font></td>";

			print "<td width=293><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'><a href=$CFG->{admin_root_url}/admin.cgi?db=$file&do=editor_table_form>Properties</a></td>";

			foreach $t (@tables) {

				if ($file eq $t) { $noshow = 1; }
	
			}

			if ($noshow) { print "<td>Drop</td>"; }

			else { print "<td><font face=Tahoma,Arial,Helvetica' size='2' color='#000000'><a href='?drop=1&table=$file'>Drop</a></td>"; }

			$noshow = 0;
		
		}

	}

	print qq|</tr></table></td></tr></table></td></tr></table>|;

	&printCreateForm;


}

sub createTable {
#---------------------------------------------------
#
	# create the table and the first field

	my $c = $DB->creator($IN->param('tablename'));

	my $i = 1;

	my @values1 = split(/\s+/, $IN->param('values1'));
	my @form_names1 = split(/\s+/, $IN->param('form_names1'));
		
	$c->cols($IN->param('column'.$i) => {
		pos => $i,
       	type => $IN->param('type'.$i),
        size => $IN->param('size'.$i),
		values => \@values1,
		not_null => $IN->param('not_null'.$i),
		default => $IN->param('default'.$i),
		form_display => $IN->param('form_display'.$i),
		form_type => $IN->param('form_type'.$i),
		form_size => $IN->param('form_size'.$i),
		form_names => \@form_names1,
		file_save_in => $IN->param('file_save_in'.$i),
		file_save_url => $IN->param('file_save_url'.$i),
		file_save_scheme => $IN->param('file_save_scheme'.$i),
		file_max_size => $IN->param('file_max_size'.$i),
		regex => $IN->param('regex'.$i)

	});

    	$c->create or die "Unable to create: $GT::SQL::error";

	# create the rest of the fields

	my $e = $DB->editor($IN->param('tablename'));

	for (my $i=2; $i <= $IN->param('fields'); $i++) {	

		my @values = split(/\s+/, $IN->param('values'.$i));
		my @form_names = split(/\s+/, $IN->param('form_names'.$i));

		$e->add_col($IN->param('column'.$i) => {
			pos => $i,
        	type => $IN->param('type'.$i),
            size => $IN->param('size'.$i),
			values => \@values,
			not_null => $IN->param('not_null'.$i),
			default => $IN->param('default'.$i),
			form_display => $IN->param('form_display'.$i),
			form_type => $IN->param('form_type'.$i),
			form_size => $IN->param('form_size'.$i),
			form_names => \@form_names,
			file_save_in => $IN->param('file_save_in'.$i),
			file_save_url => $IN->param('file_save_url'.$i),
			file_save_scheme => $IN->param('file_save_scheme'.$i),
			file_max_size => $IN->param('file_max_size'.$i),
			regex => $IN->param('regex'.$i)

		}) or die "Unable to add column: $GT::SQL::error";

	}
}

sub drop_confirm {
#---------------------------------------------------
#

	my $t = $IN->param('table');

	print qq~

<form method="POST">
	<p><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>Are you sure you want to drop the table:<b> $t</b></p>
	<p><input type="radio" value="1" name="confirm"> Yes</p>
	<p><input type="radio" value="2" checked name="confirm"> No</p>
	<p><input type="submit" value="Submit"></p>
	<input type=hidden name=table value=$t>
	<input type=hidden name=drop value=1>
	<p><b>Warning:</b> Once the table is dropped, all of its fields will be erased!</font></p>
</form>

	~;

}

sub printTableHeader {
#---------------------------------------------------
#
print qq~

<html>
<head>
<title>Links Tables</title>
</head>
<body>

<table border=1 cellpadding=0 cellspacing=0>
    <tr>
        <td>
            <table border=0 bgcolor="#FFFFFF" cellpadding=3 cellspacing=3 width=500 valign=top>
                <tr>
                    <td align=left bgcolor="navy">
                        <font face='Arial' size='2' color='#FFFFFF'><b>Links 
						Tables</b></font></td>
                </tr>
                <tr>
                    <td>
                        <p>
							<table border="0" width="100%">
								<tr>
									<td width="293"><b><font face='Tahoma,Arial,Helvetica' size='2' color='#000000'>
									Table</font></b></td>
									<td width="483" colspan="2">
									<b>
									<font face="Tahoma,Arial,Helvetica" size="2">
									Action</font></b></td>
								</tr>
~;


}